
if (!isObject(gotflag)) {
    new ScriptObject(gotflag) {
        class = gotflag;
    };
}


function gotflagClientJoinHandler(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid) {
    
    if(StrStr(%msgString, "Welcome to Tribes") != -1) {
        gotflag.clientid = %clientId;
        gotflag.clientname = %clientName;
        error("client name " @ gotflag.clientname );
    }
}

function gotflagJoinTeamHandler(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId){
    if (gotflag.clientid == %clientid) { 
        echo("got teamid");
        gotflag.team = %teamid;
    }
}


function gotflagFlagTakenHandler(%msgType, %msgString, %clientName, %a2, %a3, %a4){
    
    if (gotflag.clientname $= %clientName) {
        gotFlagHudCreate();
    }       
}

function gotflagFlagDroppedHandler(%msgType, %msgString, %clientName, %a2, %teamid, %a4){
    
    if (gotflag.team != %teamid) {
        gotFlagHudDestroy();
    }       

}

function gotFlagHudSetup(){

    new GuiControlProfile ("gotFlagHudLabelProfile"){
        fontType = "Univers Condensed";
        fontSize = 16;
        fontColor = "255 255 255";
        justify = "left";
    };        
}

function gotFlagHudCreate(){
    
    gotFlagHudDestroy();
    
    %x = getWord(retCenterHud.position, 0)+110;
    %y = getWord(retCenterHud.position, 1)+160;
        
    new ShellFieldCtrl(gotFlagHud)
    {
        profile = "ShellFieldProfile";
        horizSizing = "left";
        vertSizing = "bottom";
        position = %x SPC %y;
        extent = "40 16";
        minExtent = "8 8";
        visible = "1";
                    
        new GuiTextCtrl()
        {
            profile = "gotFlagHudLabelProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "3 0";
            extent = "40 20";
            visible = "1";
            text = "Holding";
        };
    };

    playgui.add(gotFlagHud);
}

function gotFlagHudDestroy(){
        
        if (isObject(gotFlagHud))
        {
                playGui.remove(gotFlagHud);
                gotFlagHud.delete();
        }
}


package gotflag {

    function DispatchLaunchMode(){
            gotFlagHudSetup();
            parent::DispatchLaunchMode();
    }


    function BuildMissionList(){
        
        addMessageCallback('MsgClientJoin',gotflagClientJoinHandler);
        addMessageCallback('MsgClientJoinTeam',gotflagJoinTeamHandler);
        
        addMessageCallback('MsgCTFFlagTaken',gotflagFlagTakenHandler);
        addMessageCallback('MsgCTFFlagDropped',gotflagFlagDroppedHandler);
        addMessageCallback('MsgCTFFlagCapped',gotflagFlagDroppedHandler);
        
        return parent::BuildMissionList();
    }    

};

activatePackage("gotflag");

